## hol-light 3.0.0

=== Makefile ===
###############################################################################
# Makefile for HOL Light                                                      #
#                                                                             #
# Simple "make" just builds the camlp4/camlp5 syntax extension "pa_j.cmo",    #
# which is necessary to load the HOL Light core into the OCaml toplevel.      #
#                                                                             #
# See the README file for more detailed information about the build process.  #
#                                                                             #
# Thanks to Carl Witty for 3.07 and 3.08 ports of pa_j.ml and this process.   #
###############################################################################

# Installation directory for standalone binaries. Set here to the user's
# binary directory. You may want to change it to something like /usr/local/bin

BINDIR=${HOME}/bin

# This is the list of source files in the HOL Light core

HOLSRC=system.ml lib.ml fusion.ml basics.ml nets.ml preterm.ml          \
       parser.ml printer.ml equal.ml bool.ml drule.ml tactics.ml        \
       itab.ml simp.ml theorems.ml ind_defs.ml class.ml trivia.ml       \
       canon.ml meson.ml firstorder.ml metis.ml thecops.ml quot.ml      \
       impconv.ml recursion.ml pair.ml                                  \
       nums.ml arith.ml wf.ml calc_num.ml normalizer.ml grobner.ml      \
       ind_types.ml lists.ml realax.ml calc_int.ml realarith.ml         \
       real.ml calc_rat.ml int.ml sets.ml iterate.ml cart.ml define.ml  \
       help.ml database.ml update_database.ml hol_lib.ml hol_loader.ml

# Some parameters to help decide how to build things

OCAML_VERSION=`ocamlc -version | cut -c1-4`
OCAML_BINARY_VERSION=`ocamlc -version | cut -c1-3`
OCAML_UNARY_VERSION=`ocamlc -version | cut -c1`
CAMLP5_BINARY_VERSION=`camlp5 -v 2>&1 | cut -f3 -d' ' | cut -c1-4`
CAMLP5_UNARY_VERSION=`camlp5 -v 2>&1 | cut -f3 -d' ' | cut -c1`
CAMLP5_VERSION=`camlp5 -v 2>&1 | cut -f3 -d' ' | cut -f1-3 -d'.' | cut -f1 -d'-' | cut -c1-6`

# If set to 1, build hol_lib.cmo and make hol.sh to use it.
# NOTE: This extends the trusted base of HOL Light to include the inliner
# script, inline_load.ml. inline_load.ml is an OCaml program that receives
# an HOL Light proof and replaces the loads/loadt/needs function invocations
# with their actual contents. Please turn this flag on only if having this
# additional trusted base is considered okay.

HOLLIGHT_USE_MODULE?=0

# Main target

default: update_database.ml pa_j.cmo hol.sh;

# Create a local OPAM switch and install dependencies on it.
# This will use the latest OCaml version that fully supports features of
# HOL Light.
# ledit is installed for line editing of OCaml REPL
switch:; \
  opam update ; \
  opam switch create . ocaml-base-compiler.4.14.0 ; \
  eval $(opam env) ; \
  opam install -y zarith ledit ; \
  opam pin -y add camlp5 8.03.00

switch-5:; \
  opam update ; \
  opam switch create . ocaml-base-compiler.5.2.0 ; \
  eval $(opam env) ; \
  opam install -y zarith ledit ; \
  opam pin -y add camlp5 8.03.00

# Choose an appropriate "update_database.ml" file

update_database.ml:; \
  if [ ${OCAML_VERSION} = "4.14" ] ; \
  then cp update_database/update_database_4.14.ml update_database.ml ; \
  else cp update_database/update_database_${OCAML_UNARY_VERSION}.ml update_database.ml ; \
  fi

# Build the camlp4 syntax extension file (camlp5 for OCaml >= 3.10)

pa_j.cmo: pa_j.ml; if test ${OCAML_BINARY_VERSION} = "3.0" ; \
                   then ocamlc -c -pp "camlp4r pa_extend.cmo q_MLast.cmo" -I `camlp4 -where` pa_j.ml ; \
                   elif test ${OCAML_BINARY_VERSION} = "3.1" -o ${OCAML_VERSION} = "4.00" -o ${OCAML_VERSION} = "4.01"  -o ${OCAML_VERSION} = "4.02" -o ${OCAML_VERSION} = "4.03" -o ${OCAML_VERSION} = "4.04" -o ${OCAML_VERSION} = "4.05" ; \
                   then ocamlc -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo" -I `camlp5 -where` pa_j.ml ; \
                   else ocamlc -safe-string -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo" -I `camlp5 -where` -I `ocamlfind query camlp-streams` pa_j.ml ; \
                   fi

# Choose an appropriate camlp4 or camlp5 syntax extension.
#
# For OCaml < 3.10 (OCAML_BINARY_VERSION = "3.0"), this uses the built-in
# camlp4, and in general there are different versions for each OCaml version
#
# For OCaml >= 3.10 (OCAML_BINARY_VERSION = "3.1" or "4.x"), this uses the
# separate program camlp5. Now the appropriate syntax extensions is determined
# based on the camlp5 version. The main distinction is < 6.00 and >= 6.00, but
# there are some other incompatibilities, unfortunately.

pa_j.ml: pa_j/pa_j_3.07.ml pa_j/pa_j_3.08.ml pa_j/pa_j_3.09.ml \
         pa_j/pa_j_3.1x_5.xx.ml pa_j/pa_j_3.1x_6.xx.ml \
         pa_j/pa_j_4.xx_8.00.ml pa_j/pa_j_4.xx_8.02.ml \
         pa_j/pa_j_4.xx_8.03.ml; \
        if test ${OCAML_BINARY_VERSION} = "3.0"  ; \
        then cp pa_j/pa_j_${OCAML_VERSION}.ml pa_j.ml ; \
        elif test ${CAMLP5_BINARY_VERSION} = "8.00" -o ${CAMLP5_BINARY_VERSION} = "8.02" -o ${CAMLP5_BINARY_VERSION} = "8.03" ; \
        then cp pa_j/pa_j_4.xx_${CAMLP5_BINARY_VERSION}.ml pa_j.ml; \
        elif test ${CAMLP5_UNARY_VERSION} = "7" ; \
        then if test ${CAMLP5_VERSION} = "7.01" -o ${CAMLP5_VERSION} = "7.02" -o ${CAMLP5_VERSION} = "7.03" -o ${CAMLP5_VERSION} = "7.04" -o ${CAMLP5_VERSION} = "7.05" -o ${CAMLP5_VERSION} = "7.06" ; \
          then cp pa_j/pa_j_4.xx_7.06.ml pa_j.ml; \
          else cp pa_j/pa_j_4.xx_7.xx.ml pa_j.ml; \
          fi \
        elif test ${CAMLP5_VERSION} = "6.02.1" ; \
        then cp pa_j/pa_j_3.1x_6.02.1.ml pa_j.ml; \
        elif test ${CAMLP5_VERSION} = "6.02.2" -o ${CAMLP5_VERSION} = "6.02.3" -o ${CAMLP5_VERSION} = "6.03" -o ${CAMLP5_VERSION} = "6.04" -o ${CAMLP5_VERSION} = "6.05" -o ${CAMLP5_VERSION} = "6.06" ; \
        then cp pa_j/pa_j_3.1x_6.02.2.ml pa_j.ml; \
        elif test ${CAMLP5_VERSION} = "6.06" -o ${CAMLP5_VERSION} = "6.07" -o ${CAMLP5_VERSION} = "6.08" -o ${CAMLP5_VERSION} = "6.09" -o ${CAMLP5_VERSION} = "6.10" -o ${CAMLP5_VERSION} = "6.11" -o ${CAMLP5_VERSION} = "6.12" -o ${CAMLP5_VERSION} = "6.13" -o ${CAMLP5_VERSION} = "6.14" -o ${CAMLP5_VERSION} = "6.15" -o ${CAMLP5_VERSION} = "6.16" -o ${CAMLP5_VERSION} = "6.17" ; \
        then cp pa_j/pa_j_3.1x_6.11.ml pa_j.ml; \
        else cp pa_j/pa_j_3.1x_${CAMLP5_UNARY_VERSION}.xx.ml pa_j.ml; \
        fi

# Choose an appropriate bignum library.

bignum.cmo: bignum_zarith.ml bignum_num.ml ; \
        if test ${OCAML_VERSION} = "4.14" -o ${OCAML_UNARY_VERSION} = "5" ; \
        then ocamlfind ocamlc -package zarith -c -o bignum.cmo bignum_zarith.ml ; \
        else ocamlc -c -o bignum.cmo bignum_num.ml ; \
        fi

bignum.cmx: bignum_zarith.ml bignum_num.ml ; \
        if test ${OCAML_VERSION} = "4.14" -o ${OCAML_UNARY_VERSION} = "5" ; \
        then ocamlfind ocamlopt -package zarith -c -o bignum.cmx bignum_zarith.ml ; \
        else ocamlopt -c -o bignum.cmx bignum_num.ml ; \
        fi

hol_loader.cmo: hol_loader.ml ; \
        ocamlc -verbose -c hol_loader.ml -o hol_loader.cmo

hol_loader.cmx: hol_loader.ml ; \
        ocamlopt -verbose -c hol_loader.ml -o hol_loader.cmx

hol_lib_inlined.ml: hol_lib.ml inline_load.ml ; \
        HOLLIGHT_DIR="`pwd`" ocaml inline_load.ml hol_lib.ml hol_lib_inlined.ml -omit-prelude

hol_lib.cmo: pa_j.cmo hol_lib_inlined.ml hol_loader.cmo bignum.cmo ; \
        ocamlc -verbose -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo -I . pa_j.cmo" hol_loader.cmo hol_lib_inlined.ml bignum.cmo -o hol_lib.cmo

hol_lib.cma: hol_lib.cmo bignum.cmo hol_loader.cmo ; \
        ocamlfind ocamlc -package zarith -linkpkg -a -o hol_lib.cma bignum.cmo hol_loader.cmo hol_lib.cmo

hol_lib.cmx: pa_j.cmo hol_lib_inlined.ml hol_loader.cmx bignum.cmx ; \
        OCAMLRUNPARAM=l=1000000000 ocamlopt.byte -verbose -c \
              -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo -I . pa_j.cmo" \
              hol_lib_inlined.ml hol_loader.cmx bignum.cmx -o hol_lib.cmx

hol_lib.cmxa: hol_lib.cmx hol_loader.cmx bignum.cmx ; \
        ocamlfind ocamlopt -package zarith -a -o hol_lib.cmxa bignum.cmx hol_loader.cmx hol_lib.cmx

# Create a bash script 'hol.sh' that loads 'hol.ml' in OCaml REPL.

hol.sh: pa_j.cmo ${HOLSRC} bignum.cmo hol_loader.cmo update_database.ml
	if [ `uname` = "Linux" ] || [ `uname` = "Darwin" ] ; then \
		if [ ${OCAML_UNARY_VERSION} = "5" ] || [ ${OCAML_VERSION} = "4.14" ] ; then \
			ocamlfind ocamlmktop -package zarith -o ocaml-hol zarith.cma bignum.cmo hol_loader.cmo ; \
			sed "s^__DIR__^`pwd`^g; s^__USE_MODULE__^$(HOLLIGHT_USE_MODULE)^g" hol_4.14.sh > hol.sh ; \
		else \
			ocamlmktop -o ocaml-hol nums.cma bignum.cmo hol_loader.cmo ; \
			sed "s^__DIR__^`pwd`^g; s^__USE_MODULE__^$(HOLLIGHT_USE_MODULE)^g" hol_4.sh > hol.sh ; \
		fi ; \
		chmod +x hol.sh ; \
	else \
		echo 'FAILURE: hol.sh assumes Linux' ; \
	fi

# If HOLLIGHT_USE_MODULE is set, add hol_lib.cmo to dependency of hol.sh
# Also, build unit_tests using OCaml bytecode compiler as well as OCaml native compiler.

ifeq ($(HOLLIGHT_USE_MODULE),1)
hol.sh: hol_lib.cmo
unit_tests_inlined.ml: unit_tests.ml inline_load.ml ; \
        HOLLIGHT_DIR="`pwd`" ocaml inline_load.ml unit_tests.ml unit_tests_inlined.ml
unit_tests.byte: unit_tests_inlined.ml hol_lib.cmo inline_load.ml hol.sh ; \
        ocamlfind ocamlc -package zarith -linkpkg -pp "`./hol.sh -pp`" \
        -I . bignum.cmo hol_loader.cmo hol_lib.cmo unit_tests_inlined.ml -o unit_tests.byte
unit_tests.native: unit_tests_inlined.ml hol_lib.cmx inline_load.ml hol.sh ; \
        ocamlfind ocamlopt -package zarith -linkpkg -pp "`./hol.sh -pp`" \
        -I . bignum.cmx hol_loader.cmx hol_lib.cmx unit_tests_inlined.ml -o unit_tests.native

default: hol_lib.cma hol_lib.cmxa unit_tests.byte unit_tests.native
endif

# TODO: update this and hol.* commands to use one of checkpointing  tools
# other than ckpt.
# Build a standalone hol image called "hol" (needs Linux and ckpt program)

hol: pa_j.cmo ${HOLSRC} update_database.ml;                    \
     if test `uname` = Linux; then                                      \
     echo -e '#use "make.ml";;\nloadt "update_database.ml";;\nself_destruct "";;' | ckpt -a SIGUSR1 -n hol.snapshot ocaml;\
     mv hol.snapshot hol;                                               \
     else                                                               \
     echo '******************************************************';     \
     echo 'FAILURE: Image build assumes Linux and ckpt program';        \
     echo '******************************************************';     \
     fi

# Build an image with multivariate calculus preloaded.

hol.multivariate: ./hol                                                 \
     Library/card.ml Library/permutations.ml Library/products.ml        \
     Library/floor.ml Multivariate/misc.ml Library/iter.ml              \
     Multivariate/metric.ml Multivariate/vectors.ml                     \
     Multivariate/determinants.ml Multivariate/topology.ml              \
     Multivariate/convex.ml Multivariate/paths.ml                       \
     Multivariate/polytope.ml Multivariate/degree.ml                    \
     Multivariate/derivatives.ml Multivariate/clifford.ml               \
     Multivariate/integration.ml Multivariate/measure.ml                \
     Multivariate/multivariate_database.ml update_database.ml;          \
     echo -e 'loadt "Multivariate/make.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with multivariate analysis";;' | ./hol; mv hol.snapshot hol.multivariate;

# Build an image with analysis and SOS procedure preloaded

hol.sosa: ./hol                                                         \
     Library/analysis.ml Library/transc.ml                              \
     Examples/sos.ml update_database.ml;                                \

=== LP_arith/Makefile ===
CDDLIBPATH=/usr/lib/x86_64-linux-gnu
CDDINCLUDEPATH=/usr/include/cdd

GXX = g++
CC = $(GXX)
CCLD = $(CC)


.SUFFIXES: .c .o

COMPILE = $(CC) -O2 -DHAVE_LIBGMP=1 -DGMPRATIONAL -I. -I$(CDDLIBPATH) -I$(CDDINCLUDEPATH)

LINK = $(CCLD) $(AM_CFLAGS) $(CFLAGS) $(AM_LDFLAGS) $(LDFLAGS) -o $@

.c.o:
	$(COMPILE) -c `test -f '$<' || echo ''`$<

all: cdd_cert

cdd_cert: cdd_cert.o
	$(LINK) cdd_cert.o $(CDDLIBPATH)/libcddgmp.so -l gmp

clean:
	rm -f *~ *.o cdd_cert cdd_cert.exe

=== Mizarlight/Makefile ===
#
# Syntax extensions to support Mizar Light: new infix operators
#

# Build the camlp4 syntax extension file

pa_f.cmo: pa_f.ml; if test `ocamlc -version | cut -c1-3` = "3.0" ; \
                   then ocamlc -c -pp "camlp4r pa_extend.cmo q_MLast.cmo" -I +camlp4 pa_f.ml; \
                   else ocamlfind ocamlc -package camlp5 -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo" -I +camlp5 pa_f.ml; \
                   fi

clean:; rm -f pa_f.cmi pa_f.cmo

=== Proofrecording/hol_light/Makefile ===
###############################################################################
# Makefile for HOL Light                                                      #
#                                                                             #
# Simple "make" just builds the camlp4 syntax extension "pa_j.cmo", which is  #
# necessary to load the HOL Light core into the OCaml toplevel.               #
#                                                                             #
# The later options such as "make hol" create standalone images, but only     #
# work under Linux when the "ckpt" checkpointing program is installed.        #
#                                                                             #
# See the README file for more detailed information about the build process.  #
#                                                                             #
# Thanks to Carl Witty for 3.07 and 3.08 ports of pa_j.ml and this process.   #
###############################################################################

# Installation directory for standalone binaries. Set here to the user's
# binary directory. You may want to change it to something like /usr/local/bin

BINDIR=${HOME}/bin

# This is the list of source files in the HOL Light core

HOLSRC=system.ml lib.ml fusion.ml basics.ml nets.ml preterm.ml          \
       parser.ml printer.ml equal.ml bool.ml drule.ml tactics.ml        \
       itab.ml simp.ml theorems.ml ind_defs.ml class.ml trivia.ml       \
       canon.ml meson.ml metis.ml quot.ml recursion.ml pair.ml          \
       nums.ml arith.ml wf.ml calc_num.ml normalizer.ml grobner.ml      \
       ind_types.ml lists.ml realax.ml calc_int.ml realarith.ml         \
       real.ml calc_rat.ml int.ml sets.ml iterate.ml cart.ml define.ml  \
       help.ml database.ml update_database.ml

# Some parameters to help decide how to build things

OCAML_VERSION=`ocamlc -version | cut -c1-4`
OCAML_BINARY_VERSION=`ocamlc -version | cut -c1-3`
CAMLP5_BINARY_VERSION=`camlp5 -v 2>&1 | cut -f3 -d' ' | cut -c1`
CAMLP5_VERSION=`camlp5 -v 2>&1 | cut -f3 -d' ' | cut -f1-3 -d'.' | cut -c1-6`

# Build the camlp4 syntax extension file (camlp5 for OCaml >= 3.10)

pa_j.cmo: sources pa_j.ml; if test ${OCAML_BINARY_VERSION} = "3.0" ; \
                   then ocamlc -c -pp "camlp4r pa_extend.cmo q_MLast.cmo" -I `camlp4 -where` pa_j.ml ; \
                   else if test ${OCAML_BINARY_VERSION} = "3.1" -o ${OCAML_VERSION} = "4.00" -o ${OCAML_VERSION} = "4.01"  -o ${OCAML_VERSION} = "4.02" -o ${OCAML_VERSION} = "4.03" -o ${OCAML_VERSION} = "4.04" -o ${OCAML_VERSION} = "4.05" ; \
                        then  ocamlc -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo" -I `camlp5 -where` pa_j.ml ; \
                        else ocamlc -safe-string -c -pp "camlp5r pa_lexer.cmo pa_extend.cmo q_MLast.cmo" -I `camlp5 -where` pa_j.ml ; \
                        fi \
                   fi

# Copy over and modify the sources

sources:; cp ../../*.ml .; \
          cp -f ../diffs/*.ml .; \
          java -jar ../tools/nametheorems.jar *.ml; \
          cp -f ../../pa_j_*.ml .; \
          rm *.ml.old

# Choose an appropriate camlp4 or camlp5 syntax extension.
#
# For OCaml < 3.10 (OCAML_BINARY_VERSION = "3.0"), this uses the built-in
# camlp4, and in general there are different versions for each OCaml version
#
# For OCaml >= 3.10 (OCAML_BINARY_VERSION = "3.1" or "4.x"), this uses the
# separate program camlp5. Now the appropriate syntax extensions is determined
# based on the camlp5 version. The main distinction is < 6.00 and >= 6.00, but
# there are some other incompatibilities, unfortunately.

pa_j.ml: pa_j_3.07.ml pa_j_3.08.ml pa_j_3.09.ml pa_j_3.1x_5.xx.ml pa_j_3.1x_6.xx.ml; \
        if test ${OCAML_BINARY_VERSION} = "3.0"  ; \
        then cp pa_j_${OCAML_VERSION}.ml pa_j.ml ; \
        else if test ${CAMLP5_BINARY_VERSION} = "7" ; \
             then cp pa_j_4.xx_7.xx.ml pa_j.ml ; \
             else if test ${CAMLP5_VERSION} = "6.02.1" ; \
                  then cp pa_j_3.1x_6.02.1.ml pa_j.ml; \
                  else if test ${CAMLP5_VERSION} = "6.02.2" -o ${CAMLP5_VERSION} = "6.02.3" -o ${CAMLP5_VERSION} = "6.03" -o ${CAMLP5_VERSION} = "6.04" -o ${CAMLP5_VERSION} = "6.05" -o ${CAMLP5_VERSION} = "6.06" ; \
                       then cp pa_j_3.1x_6.02.2.ml pa_j.ml; \
                       else if test ${CAMLP5_VERSION} = "6.06" -o ${CAMLP5_VERSION} = "6.07" -o ${CAMLP5_VERSION} = "6.08" -o ${CAMLP5_VERSION} = "6.09" -o ${CAMLP5_VERSION} = "6.10" -o ${CAMLP5_VERSION} = "6.11" -o ${CAMLP5_VERSION} = "6.12" -o ${CAMLP5_VERSION} = "6.13" -o ${CAMLP5_VERSION} = "6.14" -o ${CAMLP5_VERSION} = "6.15" -o ${CAMLP5_VERSION} = "6.16" -o ${CAMLP5_VERSION} = "6.17" ; \
                            then cp pa_j_3.1x_6.11.ml pa_j.ml; \
                            else cp pa_j_3.1x_${CAMLP5_BINARY_VERSION}.xx.ml pa_j.ml; \
                            fi \
                       fi \
                  fi \
             fi \
        fi

# Compile depgraph

depgraph.ml:; cp ../diffs/depgraph.ml .

depgraph: depgraph.ml; ocamlc -a -I +ocamlgraph graph.cma -o depgraph.cma depgraph.ml


# Create a top-level using str and depgraph

top: depgraph; ocamlmktop -o top -I +ocamlgraph graph.cma depgraph.cma str.cma

# Build a standalone hol image called "hol" (needs Linux and ckpt program)

hol: pa_j.cmo ${HOLSRC} update_database.ml;                    \
     if test `uname` = Linux; then                                      \
     echo -e '#use "make.ml";;\nloadt "update_database.ml";;\nself_destruct "";;' | ckpt -a SIGUSR1 -n hol.snapshot ocaml;\
     mv hol.snapshot hol;                                               \
     else                                                               \
     echo '******************************************************';     \
     echo 'FAILURE: Image build assumes Linux and ckpt program';        \
     echo '******************************************************';     \
     fi

# Build an image with multivariate calculus preloaded.

hol.multivariate: ./hol                                                 \
     Library/card.ml Library/permutations.ml Library/products.ml        \
     Library/floor.ml Multivariate/misc.ml Library/iter.ml              \
     Multivariate/metric.ml Multivariate/vectors.ml                     \
     Multivariate/determinants.ml Multivariate/topology.ml              \
     Multivariate/convex.ml Multivariate/paths.ml                       \
     Multivariate/polytope.ml Multivariate/degree.ml                    \
     Multivariate/derivatives.ml Multivariate/clifford.ml               \
     Multivariate/integration.ml Multivariate/measure.ml                \
     Multivariate/multivariate_database.ml update_database.ml;          \
     echo -e 'loadt "Multivariate/make.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with multivariate analysis";;' | ./hol; mv hol.snapshot hol.multivariate;

# Build an image with analysis and SOS procedure preloaded

hol.sosa: ./hol                                                         \
     Library/analysis.ml Library/transc.ml                              \
     Examples/sos.ml update_database.ml;                                \
     echo -e 'loadt "Library/analysis.ml";;\nloadt "Library/transc.ml";;\nloadt "Examples/sos.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with analysis and SOS";;' | ./hol; mv hol.snapshot hol.sosa;

# Build an image with cardinal arithmetic preloaded

hol.card: ./hol Library/card.ml; update_database.ml;                    \
        echo -e 'loadt "Library/card.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with cardinal arithmetic";;' | ./hol; mv hol.snapshot hol.card;

# Build an image with multivariate-based complex analysis preloaded

hol.complex: ./hol.multivariate                                         \
        Library/binomial.ml Multivariate/complexes.ml                   \
        Multivariate/canal.ml Multivariate/transcendentals.ml           \
        Multivariate/realanalysis.ml Multivariate/moretop.ml            \
        Multivariate/cauchy.ml Multivariate/complex_database.ml         \
        update_database.ml;                                             \
        echo -e 'loadt "Multivariate/complexes.ml";;\nloadt "Multivariate/canal.ml";;\nloadt "Multivariate/transcendentals.ml";;\nloadt "Multivariate/realanalysis.ml";;\nloadt "Multivariate/cauchy.ml";;\nloadt "Multivariate/complex_database.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with multivariate-based complex analysis";;' | ./hol.multivariate; mv hol.snapshot hol.complex;

# Build all those

all: hol hol.multivariate hol.sosa hol.card hol.complex;

# Build binaries and copy them to binary directory

install: hol hol.multivariate hol.sosa hol.card hol.complex; cp hol hol.multivariate hol.sosa hol.card hol.complex ${BINDIR}

# Clean up all generated files

clean:; rm -f *.ml *.ml.old pa_j.cmi pa_j.cmo hol hol.multivariate hol.sosa hol.card

clean_all: clean; rm -f *~ *.cma *.cmi *.cmo top top.exe

=== Proofrecording/tools/Makefile ===
# Thanks to Carl Witty for 3.07 and 3.08 ports of pa_j.ml and this make procedure

OCAMLC=ocamlc -dtypes -g -pp "camlp4o ./init.cmo ./pa_j.cmo" -I +campl4  nums.cma unix.cma

CAMLP4O=camlp4o ./init.cmo ./pa_j.cmo

pa_j.cmo: pa_j.ml; ocamlc -c -pp 'camlp4r pa_extend.cmo q_MLast.cmo' -I `which camlp4 | sed -e 's/bin\/camlp4/lib\/ocaml\/camlp4/'` pa_j.ml

pa_j.ml: pa_j_3.04.ml pa_j_3.06.ml pa_j_3.07+2.ml; cp pa_j_`ocamlc -version`.ml pa_j.ml

clean:; rm -f pa_j.ml pa_j.cmi pa_j.cmo


init.cmo : init.ml
	ocamlc -I +camlp4 -c ./init.ml

core.out : srccore init.cmo pa_j.cmo
	$(OCAMLC) -o core.out core.ml

srccore :;
	cat startcore.ml > core.ml
	cat lib.ml >> core.ml
	cat lib2.ml >> core.ml
	cat type.ml >> core.ml
	cat term.ml >> core.ml
	cat proofobjects_init.ml >> core.ml
	cat proofobjects_dummy.ml >> core.ml
	cat thm.ml >> core.ml
	cat basics.ml >> core.ml
	cat nets.ml >> core.ml
	cat preterm.ml >> core.ml
	cat parser.ml >> core.ml
	cat printer.ml >> core.ml
	cat equal.ml >> core.ml
	cat bool.ml >> core.ml
	cat drule.ml >> core.ml
	cat tactics.ml >> core.ml
	cat itab.ml >> core.ml
	cat simp.ml >> core.ml
	cat theorems.ml >> core.ml
	cat ind-defs.ml >> core.ml
	cat class.ml >> core.ml
	cat trivia.ml >> core.ml
	cat canon.ml >> core.ml
	cat meson.ml >> core.ml
	cat quot.ml >> core.ml
	cat recursion.ml >> core.ml
	cat pair.ml >> core.ml
	cat num.ml >> core.ml
	cat arith.ml >> core.ml
	cat wf.ml >> core.ml
	cat calc_num.ml >> core.ml
	cat normalizer.ml >> core.ml
	cat grobner.ml >> core.ml
	cat ind-types.ml >> core.ml
	cat list.ml >> core.ml
	cat realax.ml >> core.ml
	cat calc_int.ml >> core.ml
	cat realarith.ml >> core.ml
	cat real.ml >> core.ml
	cat calc_rat.ml >> core.ml
	cat int.ml >> core.ml
	cat sets.ml >> core.ml
	cat Examples/analysis.ml >> core.ml
	cat Examples/transc.ml >> core.ml
	cat Complex/complex.ml >> core.ml
	cat Complex/cpoly.ml >> core.ml
	cat Complex/fundamental.ml >> core.ml
	cat Complex/quelim.ml >> core.ml
	cat Complex/polyconv.ml >> core.ml
	cat Complex/grobner.ml >> core.ml
	cat Complex/real.ml >> core.ml

srcexamples:;
	cat Complex/quelim_examples.ml >> core.ml
	cat Examples/binomial.ml >> core.ml
	cat Examples/wo.ml >> core.ml
	cat Examples/card.ml >> core.ml
	cat Examples/cong.ml >> core.ml
	cat Examples/cooper.ml >> core.ml
	cat Examples/floor.ml >> core.ml
	cat Examples/forster.ml >> core.ml
	cat Examples/lagrange.ml >> core.ml
	cat Examples/mccarthy.ml >> core.ml
	cat Examples/multivariate.ml >> core.ml
	cat Examples/multiwf.ml >> core.ml
	cat Examples/prime.ml >> core.ml
	cat Examples/pell.ml >> core.ml
	cat Examples/poly.ml >> core.ml
	cat Examples/polylog.ml >> core.ml
	cat Examples/rectypes.ml >> core.ml
	cat Examples/rstc.ml >> core.ml
	cat Examples/reduct.ml >> core.ml

=== debian/changelog ===
hol-light (1:3.0.0-2build7) plucky; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Mar 2025 18:43:55 +0100

hol-light (1:3.0.0-2build6) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Feb 2025 21:36:10 +0100

hol-light (1:3.0.0-2build5) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jan 2025 22:22:22 +0100

hol-light (1:3.0.0-2build4) plucky; urgency=medium

  * Rebuild against latest camlp5

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 26 Jan 2025 16:39:33 -0500

hol-light (1:3.0.0-2build3) plucky; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jan 2025 09:09:29 +0100

hol-light (1:3.0.0-2build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:26:30 +0100

hol-light (1:3.0.0-2build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2025 18:04:46 +0100

hol-light (1:3.0.0-2) unstable; urgency=medium

  * Team upload.
  * Remove libcoq-bignums on B-D from previous upload.

 -- Bo YU <tsu.yubo@gmail.com>  Sun, 15 Dec 2024 21:49:40 +0800

hol-light (1:3.0.0-1) unstable; urgency=medium

  * Team upload.
  * Enable d/watch
    - Clear some comments on d/watch
  * New upstream version 3.0.0. (Closes: #1073882)
  * Refresh d/patches/*
    - Drop 0004-Fix-build-with-camlp5-8.03.00.patch
    - Drop default-hollight-dir
  * Add libzarith-ocaml-dev and libcoq-bignums on B-D.
  * Use $(MAKE) to build it.
  * No need to install usr/share/hol-light/* explicitly.
  * Update d/copyright
  * Bump std-ver to 4.7.0
  * Add epoch to version number

 -- Bo YU <tsu.yubo@gmail.com>  Tue, 26 Nov 2024 12:34:41 +0800

hol-light (20231021-2) unstable; urgency=medium

  * Team upload
  * Fix build with camlp5 8.03.00

 -- Stéphane Glondu <glondu@debian.org>  Sun, 30 Jun 2024 10:31:46 +0200

hol-light (20231021-1) unstable; urgency=medium

  * Team upload
  * New upstream snapshot

 -- Stéphane Glondu <glondu@debian.org>  Mon, 23 Oct 2023 15:10:13 +0200

hol-light (20230128-2) unstable; urgency=medium

  * Team upload
  * Add support for camlp5 8.02
  * Bump Standards-Version to 4.6.2

 -- Stéphane Glondu <glondu@debian.org>  Thu, 07 Sep 2023 03:44:32 +0200

hol-light (20230128-1) unstable; urgency=medium

  [ Stéphane Glondu ]
  * Team upload
  * New upstream snapshot (Closes: #1002983)

  [ Debian Janitor ]
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Use secure URI in Homepage field.
  * Bump debhelper from old 12 to 13.
    + Drop check for DEB_BUILD_OPTIONS containing "nocheck", since debhelper now
      does this.
    + debian/rules: Drop --fail-missing argument to dh_missing, which is now the
      default.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.6.0, no changes needed.

 -- Stéphane Glondu <glondu@debian.org>  Tue, 31 Jan 2023 12:10:03 +0100

hol-light (20190729-4) unstable; urgency=medium

  * Team upload
  * Fix compilation with camlp5 7.11

 -- Stéphane Glondu <glondu@debian.org>  Wed, 12 Feb 2020 05:43:48 +0100

hol-light (20190729-3) unstable; urgency=medium

  * Team upload
  * Add libnum-ocaml-dev to Build-Depends (Closes: #944277)
  * Bump debhelper compat level to 12
  * Bump Standards-Version to 4.4.1
  * Add Rules-Requires-Root: no

 -- Stéphane Glondu <glondu@debian.org>  Sun, 29 Dec 2019 13:24:09 +0100

hol-light (20190729-2) unstable; urgency=medium

  * Team upload.
  * Fix bad license in copyright file

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 15:24:03 +0200

hol-light (20190729-1) unstable; urgency=medium

  * Team Upload
  * Cherry-pick changes from git:
    - add python runtime dependency
    - bump compat level to 10
    - README.debian: updated
    - udpate std-version to 4.4.0
  * Fix lintian warning about trailing whitespace
  * Fix lintian warning about not honouring nocheck test DH parameter
  * Fix lintian warning about deprecated extra priority.
  * update VCS fields to new location
  * remove trailing newlines
  * update changelog with missing changelog entry
  * Ack previous NMU

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Jul 2019 14:54:22 +0200

hol-light (20190729-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream snapshot (Closes: #876533)
    - Patch for new ocaml and camlp5
    - tweak rules file to stop copy of the new ml file
      This is already done in upstream build system.
    - do not install .pc file in the system (Closes: #878615)
  * Update copyright file
  * Update copyright file http in https mode

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 27 Jul 2019 10:19:28 +0200

hol-light (20171023-1) unstable; urgency=medium

  * Imported upstream version 20171023
    with git hash 39d9bf8b2958a288905661f969e9ab25b5ed74aa
  * delete camlp5-7 patch - was applied upstream; refresh other patches
  * compat level 10, standards version 4.1.1
  * update rules with new pa_j implementation (Closes: #876533)
  * minor change in control file - Flyspeck is completed
  * update copyright file
  * clear executable bit deletion in rules - has been fixed upstream
  * change to priority optional as demanded by lintian
  * suggests python as demanded by lintian
  * exclude .pc directory during installation (Closes: #878615)
  * README.Debian: hints on native toplevel and testsuite updates
  * delete some trailing whitespace for lintian

 -- Hendrik Tews <hendrik@askra.de>  Sun, 29 Oct 2017 20:55:28 +0100

hol-light (20170109-2) unstable; urgency=medium

  [ Hendrik Tews ]


=== debian/control ===
Source: hol-light
Section: math
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Hendrik Tews <hendrik@askra.de>
Build-Depends:
 debhelper-compat (= 13),
 camlp5 (>= 8.02),
 libnum-ocaml-dev,
 libcamlp-streams-ocaml-dev,
 ocaml-findlib,
 dh-ocaml,
 libzarith-ocaml-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.cl.cam.ac.uk/~jrh13/hol-light/
Vcs-Git: https://salsa.debian.org/ocaml-team/hol-light.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/hol-light

Package: hol-light
Architecture: any
Depends:
 camlp5,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests:
 readline-editor,
 prover9,
 coinor-csdp,
 pari-gp,
 maxima,
 dmtcp,
 libocamlgraph-ocaml-dev,
 python
Description: HOL Light theorem prover
 HOL Light is an interactive theorem prover for Higher-Order Logic
 with a very simple logical core running in an OCaml toplevel. HOL
 Light is famous for the verification of floating-point
 arithmetic as well as for the Flyspeck project, which aimed at the
 formalization of Tom Hales' proof of the Kepler conjecture.

## hol-light 3.1.0

=== Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
        parser.ml printer.ml equal.ml bool.ml drule.ml tactics.ml        \
        itab.ml simp.ml theorems.ml ind_defs.ml class.ml trivia.ml       \
        canon.ml meson.ml firstorder.ml metis.ml thecops.ml quot.ml      \
-       impconv.ml recursion.ml pair.ml                                  \
+       impconv.ml recursion.ml pair.ml compute.ml                       \
        nums.ml arith.ml wf.ml calc_num.ml normalizer.ml grobner.ml      \
        ind_types.ml lists.ml realax.ml calc_int.ml realarith.ml         \
        real.ml calc_rat.ml int.ml sets.ml iterate.ml cart.ml define.ml  \
@@ -135,7 +135,7 @@
 hol_loader.cmx: hol_loader.ml ; \
         ocamlopt -verbose -c hol_loader.ml -o hol_loader.cmx
 
-hol_lib_inlined.ml: hol_lib.ml inline_load.ml ; \
+hol_lib_inlined.ml: ${HOLSRC} inline_load.ml ; \
         HOLLIGHT_DIR="`pwd`" ocaml inline_load.ml hol_lib.ml hol_lib_inlined.ml -omit-prelude
 
 hol_lib.cmo: pa_j.cmo hol_lib_inlined.ml hol_loader.cmo bignum.cmo ; \
@@ -185,23 +185,20 @@
 default: hol_lib.cma hol_lib.cmxa unit_tests.byte unit_tests.native
 endif
 
-# TODO: update this and hol.* commands to use one of checkpointing  tools
-# other than ckpt.
-# Build a standalone hol image called "hol" (needs Linux and ckpt program)
-
-hol: pa_j.cmo ${HOLSRC} update_database.ml;                    \
+# Build a standalone hol image called "hol" (needs Linux and DMTCP)
+
+hol: hol.sh make-checkpoint.sh update_database.ml;                      \
      if test `uname` = Linux; then                                      \
-     echo -e '#use "make.ml";;\nloadt "update_database.ml";;\nself_destruct "";;' | ckpt -a SIGUSR1 -n hol.snapshot ocaml;\
-     mv hol.snapshot hol;                                               \
+     ./make-checkpoint.sh hol "loadt \"update_database.ml\"" ;          \
      else                                                               \
      echo '******************************************************';     \
-     echo 'FAILURE: Image build assumes Linux and ckpt program';        \
+     echo 'FAILURE: Image build assumes Linux and DMTCP';               \
      echo '******************************************************';     \
      fi
 
 # Build an image with multivariate calculus preloaded.
 
-hol.multivariate: ./hol                                                 \
+hol.multivariate: hol.sh make-checkpoint.sh Multivariate/make.ml        \
      Library/card.ml Library/permutations.ml Library/products.ml        \
      Library/floor.ml Multivariate/misc.ml Library/iter.ml              \
      Multivariate/metric.ml Multivariate/vectors.ml                     \
@@ -211,10 +208,14 @@
      Multivariate/derivatives.ml Multivariate/clifford.ml               \
      Multivariate/integration.ml Multivariate/measure.ml                \
      Multivariate/multivariate_database.ml update_database.ml;          \
-     echo -e 'loadt "Multivariate/make.ml";;\nloadt "update_database.ml";;\nself_destruct "Preloaded with multivariate analysis";;' | ./hol; mv hol.snapshot hol.multivariate;
+     if test `uname` = Linux; then                                      \
+     ./make-checkpoint.sh hol.multivariate "loadt \"Multivariate/make.ml\"; loadt \"update_database.ml\""; \
+     else                                                               \
+     echo '******************************************************';     \
+     echo 'FAILURE: Image build assumes Linux and DMTCP';               \
+     echo '******************************************************';     \
+     fi
 
 # Build an image with analysis and SOS procedure preloaded
 
-hol.sosa: ./hol                                                         \
-     Library/analysis.ml Library/transc.ml                              \
-     Examples/sos.ml update_database.ml;                                \
+hol.sosa: hol.sh make-checkpoint.sh                                     \

=== debian/changelog ===
hol-light (1:3.1.0-1) unstable; urgency=medium

  * Team upload
  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Sat, 20 Dec 2025 03:58:13 +0100

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,7 @@
  ocaml-findlib,
  dh-ocaml,
  libzarith-ocaml-dev,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Homepage: https://www.cl.cam.ac.uk/~jrh13/hol-light/
 Vcs-Git: https://salsa.debian.org/ocaml-team/hol-light.git
 Vcs-Browser: https://salsa.debian.org/ocaml-team/hol-light

=== debian/watch ===
Version: 5

Source: https://github.com/jrh13/hol-light/releases
Matching-Pattern: releases/tag/(?:Release|v)@ANY_VERSION@
Downloadurlmangle: s|releases/tag|archive/refs/tags|;s|$|.zip|
Dversionmangle: auto
Repacksuffix: +dfsg
